// MainFrm.cpp : implementation of the CMainFrame class
//

#include "stdafx.h"
#include "TBCUST.h"
#include "MainFrm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CMainFrame

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_COMMAND(ID_CUSTOMIZE_ENABLE, OnCustomizeEnable)
	ON_UPDATE_COMMAND_UI(ID_CUSTOMIZE_ENABLE, OnUpdateCustomizeEnable)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
	
}

CMainFrame::~CMainFrame()
{
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct)
{
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	
	if (!m_wndToolBar0.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar0.LoadToolBar(IDR_MAINFRAME))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndToolBar1.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar1.LoadToolBar(IDR_MAINFRAME1))
	{
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}

	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT)))
	{
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}

	// TODO: Delete these three lines if you don't want the toolbar to
	//  be dockable
	m_wndToolBar0.EnableDocking(CBRS_ALIGN_ANY);
	m_wndToolBar1.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar0);
	DockControlBar(&m_wndToolBar1);

	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs)
{
	if( !CMDIFrameWnd::PreCreateWindow(cs) )
		return FALSE;
	// TODO: Modify the Window class or styles here by modifying
	//  the CREATESTRUCT cs

	return TRUE;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CMainFrame message handlers


void CMainFrame::OnCustomizeEnable() 
{
      if( m_wndToolBar0.IsOnCustomization() ) return;
      //
      CTbDlg   dlg;
      //
      dlg.AddToolbarID(IDR_MAINFRAME ,ID_VIEW_TOOLBAR    );
      dlg.AddToolbarID(IDR_MAINFRAME1,ID_VIEW_MAINFRAME1 );
      //
      m_wndToolBar0.EnableCustomization(true);
      m_wndToolBar1.EnableCustomization(true);
      //
      m_wndToolBar0.OnAddControls( dlg );
      m_wndToolBar1.OnAddControls( dlg );
      //
      if( dlg.DoCustomize() )
         while( dlg.WaitMy() );
      //
      m_wndToolBar0.SaveCustomToolbarState();
      m_wndToolBar1.SaveCustomToolbarState();
      //
      m_wndToolBar0.EnableCustomization(false);
      m_wndToolBar1.EnableCustomization(false);
}

void CMainFrame::OnUpdateCustomizeEnable(CCmdUI* pCmdUI) 
{
      pCmdUI->Enable( m_wndToolBar0.IsOnCustomization() ? FALSE : TRUE );
}

BOOL CMainFrame::OnCommand(WPARAM wParam, LPARAM lParam) 
{
      return ( m_wndToolBar0.IsOnCustomization() ? FALSE :
               CMDIFrameWnd::OnCommand(wParam, lParam) );
}
